searchNodes=[{"ref":"Exzeitable.html","title":"Exzeitable","type":"module","doc":"Exzeitable. Check README for usage instructions."},{"ref":"Exzeitable.html#__using__/1","title":"Exzeitable.__using__/1","type":"macro","doc":"Expands into the gigantic monstrosity that is Exzeitable"},{"ref":"Exzeitable.Database.html","title":"Exzeitable.Database","type":"module","doc":"Database interactions"},{"ref":"Exzeitable.Database.html#get_record_count/1","title":"Exzeitable.Database.get_record_count/1","type":"function","doc":"I want to just do a select: count(c.id)"},{"ref":"Exzeitable.Database.html#get_records/1","title":"Exzeitable.Database.get_records/1","type":"function","doc":"Get the data using query"},{"ref":"Exzeitable.Database.html#prefix_search/1","title":"Exzeitable.Database.prefix_search/1","type":"function","doc":"We only want letters to avoid SQL injection attacks"},{"ref":"Exzeitable.Database.html#tsvector_string/1","title":"Exzeitable.Database.tsvector_string/1","type":"function","doc":"Generates the magic SQL fragment that performs search dynamically. Created outside macro to bypass ecto restrictions"},{"ref":"Exzeitable.Filter.html","title":"Exzeitable.Filter","type":"module","doc":"Filtering data"},{"ref":"Exzeitable.Filter.html#fields_where/2","title":"Exzeitable.Filter.fields_where/2","type":"function","doc":"All fields where a key value is true"},{"ref":"Exzeitable.Filter.html#fields_where_not/2","title":"Exzeitable.Filter.fields_where_not/2","type":"function","doc":"All fields where a key value is false"},{"ref":"Exzeitable.Filter.html#filter_pages/2","title":"Exzeitable.Filter.filter_pages/2","type":"function","doc":"Selects the page buttons we need for pagination"},{"ref":"Exzeitable.Filter.html#parent_for/2","title":"Exzeitable.Filter.parent_for/2","type":"function","doc":"Gets the parent that the nested resource belongs to"},{"ref":"Exzeitable.Filter.html#search_enabled?/1","title":"Exzeitable.Filter.search_enabled?/1","type":"function","doc":"Returns true if any of the fields have search enabled"},{"ref":"Exzeitable.Filter.html#set_fields/1","title":"Exzeitable.Filter.set_fields/1","type":"function","doc":"Gets fields from options and merges it into the defaults"},{"ref":"Exzeitable.Format.html","title":"Exzeitable.Format","type":"module","doc":"Formatting text"},{"ref":"Exzeitable.Format.html#field/3","title":"Exzeitable.Format.field/3","type":"function","doc":"If function: true, will pass the entry to the function of the same name as the entry Else just output the field This function is tested but coveralls will not register it."},{"ref":"Exzeitable.Format.html#header/1","title":"Exzeitable.Format.header/1","type":"function","doc":"Will output the user supplied label or fall back on the atom"},{"ref":"Exzeitable.HTML.html","title":"Exzeitable.HTML","type":"module","doc":"You will need to add styling for the form, I attempted to make the classes as unopinionated as possible. Below is a SASS example for Bootstrap 4 // ############################# // ########### TABLE ########### // ############################# // div around the table .lt-table-wrapper { @extend .table-responsive; } // the table .lt-table { @extend .table; thead { @extend .thead-dark; } } // div around lt-pagination-div and lt-search-div .lt-row { @extend .row; } // ############################# // ########### SEARCH ########## // ############################# // div around the search box .lt-search-wrapper { @extend .col-xl-6; } //The search form (I don&#39;t need this) // .lt-search-form { // } .lt-search-field { @extend .form-control; @extend .mb-1; } .lt-search-field-wrapper { @extend .input-group-append; } .lt-counter-field { @extend .input-group-text; } .lt-counter-field-wrapper { @extend .input-group-append; @extend .mb-1; } // ############################# // ######## PAGINATION ######### // ############################# // div around the pagination nav .lt-pagination-wrapper { @extend .col-xl-6; } // nav around pagination ul .lt-pagination-nav { @extend .mt-1; @extend .mt-xl-0; } // ul around pagination li .lt-pagination-ul { @extend .pagination; @extend .pagination-sm; } // li around pagination links .lt-pagination-li { @extend .page-item; } // li around pagination links when active .lt-pagination-li-active { @extend .page-item; @extend .active; color: white; } // li around pagination links when disabled .lt-pagination-li-disabled { @extend .page-item; @extend .disabled; } // Base class for pagination link .lt-pagination-a { @extend .page-link; @extend .text-center; @extend .mt-1; } // Fixed width for pagination link with number .lt-pagination-width { width: 50px; } // ############################# // ####### Header Links ######## // ############################# // Hide link .lt-hide-link { @extend .mx-1; @extend .small; cursor: grabbing; } // Sort link .lt-sort-link { @extend .mx-1; @extend .small; cursor: grabbing; } // Buttons for showing hidden columns .lt-show-button { @extend .btn; @extend .btn-sm; @extend .btn-outline-secondary; @extend .m-1; cursor: grabbing; } // Buttons for showing hidden columns .lt-info-button { @extend .btn; @extend .btn-sm; @extend .btn-outline-info; @extend .m-1; cursor: grabbing; } // ############################# // ###### Action Buttons ####### // ############################# .lt-action-delete { @extend .btn; @extend .btn-sm; @extend .my-1; @extend .mr-1; @extend .btn-outline-danger; } .lt-action-new { @extend .btn; @extend .btn-sm; @extend .my-1; @extend .mr-1; @extend .btn-outline-primary; } .lt-action-show { @extend .btn; @extend .btn-sm; @extend .my-1; @extend .mr-1; @extend .btn-outline-primary; } .lt-action-edit { @extend .btn; @extend .btn-sm; @extend .my-1; @extend .mr-1; @extend .btn-outline-info; }"},{"ref":"Exzeitable.HTML.html#build_table/1","title":"Exzeitable.HTML.build_table/1","type":"function","doc":"Root function for building the HTML table"},{"ref":"Exzeitable.Validation.html","title":"Exzeitable.Validation","type":"module","doc":"Using these instead of Keyword.fetch! to provide nice easily resolvable errors."},{"ref":"Exzeitable.Validation.html#paired_options/1","title":"Exzeitable.Validation.paired_options/1","type":"function","doc":"If you have parent then you need belongs_to, and vice versa."},{"ref":"Exzeitable.Validation.html#required_options/1","title":"Exzeitable.Validation.required_options/1","type":"function","doc":"The required options"},{"ref":"README.html","title":"Exzeitable","type":"extras","doc":"Exzeitable Dynamic searchable, sortable datatable that takes a database query and a module, and makes the magic happen. Uses Phoenix Liveview and Postgres. Bootstrap friendly and easily configured for other CSS frameworks. Documentation can be found at https://hexdocs.pm/exzeitable."},{"ref":"README.html#installation","title":"Exzeitable - Installation","type":"extras","doc":"This package requires a Postgres database and Phoenix. The package can be installed by adding exzeitable and Phoenix Live View to your list of dependencies in mix.exs: def deps do [ {:exzeitable, &quot;~&gt; 0.2.0&quot;}, {:phoenix_live_view, &quot;~&gt; 0.3.0&quot;}, {:floki, &quot;&gt;= 0.0.0&quot;, only: :test} ] end"},{"ref":"README.html#getting-started","title":"Exzeitable - Getting Started","type":"extras","doc":"Migration Search requires the pg_trgm extension for Postgres. Create a new migration mix ecto.gen.migration add_pg_trgm And add the following code to your migration file def up do execute(&quot;CREATE EXTENSION pg_trgm&quot;) end def down do execute(&quot;DROP EXTENSION pg_trgm&quot;) end Then migrate mix ecto.migrate Module Add the boilerplate to a new module. defmodule YourAppWeb.Live.File do @moduledoc &quot;User&#39;s File table&quot; alias YourAppWeb.Router.Helpers, as: Routes import Ecto.Query use Exzeitable, # Required repo: YourApp.Repo, routes: Routes, path: :file_path, query: from(f in File) fields: [ image: [virtual: true], title: [hidden: true], description: [hidden: true], category: [hidden: true], filesize: [hidden: true, function: true, search: false], inserted_at: [hidden: true, function: true, label: &quot;Created&quot;], updated_at: [hidden: true, function: true, label: &quot;Updated&quot;] ], # Optional debounce: 300 # The callback that renders your table def render(assigns), do: ~L&quot;&lt;%= build_table(assigns) %&gt;&quot; # Field functions, called when virtual: true or function: true def image(socket, file) do img_tag(file.url, class: &quot;w-100&quot;) |&gt; link(to: Routes.file_path(socket, :show, file)) end def filesize, do: ... def inserted_at, do: ... def updated_at, do: ... Options can be added to either your module (as seen above), or in the template (As seen below) or both. If an option is defined in both the template option will replace the module option. The only exception is :fields which must be specified in the module. Required options repo The module for your repository. Example: YourApp.Repo routes Your route module. Example: YourAppWeb.Router.Helpers path The base path for your resource. Example: :site_path query A Ecto.Query struct, the part before you give it to the Repo. Example: from(s in Site, preload: [:users Defining your fields Under the fields key, you can define a keyword list of atoms with keyword values. The map holds the options for that field. fields: [ name: [function: true], age: [order: false], metadata: [label: &quot;Additional Information&quot;, virtual: true, hidden: true], ] The following field options are available (with their defaults): label: nil Set a custom string value for the column heading function: false Pass (socket, entry) to a function with the same name as the field hidden: false Hide the column by default (user can click show button to reveal) search: true Whether to include the column in search results. order: true Do not allow the column to be sorted (hide the sort button) virtual: false This is shorthand for [function: true, search: false, order: false] and will override those settings. Intended for creating fields that are not database backed. IMPORTANT NOTE: Search uses ts_vector, which is performed by Postgres inside the database on string fields. This means that you cannot search fields that are not string type (i.e. datetime, associations, virtual fields). Make sure to set search: false or virtual: true on such fields. Optional... options (with defaults) action_buttons: [:new, :edit, :show, :delete] A list of atoms representing action buttons avaliable for the user to use. This does not do authorization, the routes will still be available. per_page: 20 Integer representing number of entries per page. debounce: 300 Sets how many miliseconds between responding to user input on the search field. Options for nested routes If you dont know what this is then you likely don&#39;t need to worry about it. You can look at The official docs if you would like to learn more. If you define one of the below options you then need to define the other. For this example we will be using the boring example of users and posts resources &quot;/users&quot;, UserController do resources &quot;/posts&quot;, PostController end The users Exzeitable does not need the 2 options below, but the posts Exzeitable does. Because all of its routes are different. The following will be needed to make the posts Exzeitable work: belongs_to: :user parent: @user Make sure that you include the :user_id in your query. You will need to pass the parent option in from the template. Controller This is where you can specify the query that forms the default data of the table. Everything the table does is with a subset of this data. query = from(f in Files) render(conn, &quot;index.html&quot;, query: query) Template Call the table from your template &lt;h1&gt; My Awesome Files &lt;/h1&gt; &lt;%= YourAppWeb.Live.File.live_table(@conn, query: @query, action_buttons: [:show, :edit]) %&gt; CSS Almost no CSS styling is included out of the box. I have added generic classes elements in the table in the hopes of making the table as CSS framwork agnostic as possible. I have included a Bootstrap SASS example in the HTML Module"},{"ref":"README.html#contributing","title":"Exzeitable - Contributing","type":"extras","doc":"Contributions are very welcome! Open an issue or a pull request, the code, tests and documentation can always be improved and I welcome the help :)"},{"ref":"CHANGELOG.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"CHANGELOG.html#v0-2-0-2019-10-12","title":"Changelog - v0.2.0 (2019-10-12)","type":"extras","doc":"Rebuilt with Phoenix (originally was just a Mix project) Added dev environment Added acceptance tests with cypress Added additional unit tests"},{"ref":"CHANGELOG.html#v0-1-2-2019-10-11","title":"Changelog - v0.1.2 (2019-10-11)","type":"extras","doc":"Added ability to show and hide &#39;show buttons&#39; for columns Disabled use of enter key with search box (created a CSRF error) Added specs Added documentation"},{"ref":"CHANGELOG.html#v0-1-1-2019-10-09","title":"Changelog - v0.1.1 (2019-10-09)","type":"extras","doc":"Fix iOS touch issues Add inch_ex Minor documentation improvements"},{"ref":"CHANGELOG.html#v0-1-0-2019-10-03","title":"Changelog - v0.1.0 (2019-10-03)","type":"extras","doc":"Initial release"}]